/*
**	AIFF DataType
**
**	Written by Olaf `Olsen' Barthel <olsen@sourcery.han.de>
**		Public domain
**
** :ts=4
*/

	// Our custom library structure

struct ClassBase
{
	struct Library			 LibNode;			// Exec link

	struct ExecBase			*SysBase;			// Exec library
	struct DosLibrary		*DOSBase;			// Dos library
	struct Library			*IntuitionBase,		// Intuition library
							*UtilityBase,		// Utility library
							*IFFParseBase,		// IFFParse library
							*DataTypesBase,		// DataTypes library
							*SuperClassBase;	// Sound datatype
	struct SignalSemaphore	 LockSemaphore;		// Shared access semaphore
	Class					*SoundClass;		// The class this library implemnts
	BPTR					 Segment;			// Library segment pointer
	struct Hook				 AsyncHook;			// IFFHandle I/O hook
};

	// Redirect references to global data into the library base

#define SysBase			ClassBase -> SysBase
#define DOSBase			ClassBase -> DOSBase
#define IntuitionBase	ClassBase -> IntuitionBase
#define UtilityBase		ClassBase -> UtilityBase
#define IFFParseBase	ClassBase -> IFFParseBase
#define DataTypesBase	ClassBase -> DataTypesBase
#define SuperClassBase	ClassBase -> SuperClassBase
#define LockSemaphore	ClassBase -> LockSemaphore
#define SoundClass		ClassBase -> SoundClass
#define Segment			ClassBase -> Segment
#define AsyncHook		ClassBase -> AsyncHook
