
******************************************************************************
*
* Flowerpower's AOM_Raw Datatype
*
* Written by Christian Buchner and David N. Junod
*
******************************************************************************
* RomTag.asm
*
*

VERSION		EQU	40
REVISION	EQU	2
LIBNAME		MACRO
		dc.b	'aom_raw.datatype',0
		ENDM
VSTRING		MACRO
		dc.b	'aom_raw 40.2 (6.3.95) by Christian Buchner',13,10,0
		ENDM

;---------------------------------------------------------------------------

	INCLUDE "exec/types.i"
	INCLUDE "exec/libraries.i"
	INCLUDE "exec/lists.i"
	INCLUDE "exec/alerts.i"
	INCLUDE "exec/initializers.i"
	INCLUDE "exec/resident.i"
	INCLUDE "libraries/dos.i"

	INCLUDE "classbase.i"

;---------------------------------------------------------------------------

	XREF	_LibInit
	XREF	_LibOpen
	XREF	_LibClose
	XREF	_LibExpunge
	XREF	_LibReserved

	XREF	_ObtainClassEngine

;	XREF    ENDCODE

;---------------------------------------------------------------------------


;---------------------------------------------------------------------------

	SECTION Code

; First executable location, must return an error to the caller
Start:
	moveq   #-1,d0
	rts

;-----------------------------------------------------------------------

ROMTAG:
	DC.W	RTC_MATCHWORD	; UWORD RT_MATCHWORD
	DC.L	ROMTAG		; APTR  RT_MATCHTAG
	DC.L	ENDCODE		; APTR  RT_ENDSKIP
	DC.B	RTF_AUTOINIT	; UBYTE RT_FLAGS
	DC.B	VERSION		; UBYTE RT_VERSION
	DC.B	NT_LIBRARY	; UBYTE RT_TYPE
	DC.B	0		; BYTE  RT_PRI
	DC.L	LibName		; APTR  RT_NAME
	DC.L	LibId		; APTR  RT_IDSTRING
	DC.L	LibInitTable	; APTR  RT_INIT

ENDCODE:

LibName LIBNAME
	DC.B '$VER: '
LibId   VSTRING

	CNOP    0,4

LibInitTable:
	DC.L	ClassBase_SIZEOF
	DC.L	LibFuncTable
	DC.L	LibDataTable
	DC.L	_LibInit

V_DEF	MACRO
	DC.W	\1+(*-LibFuncTable)
	ENDM

LibFuncTable:
	DC.W	-1
	V_DEF	_LibOpen
	V_DEF	_LibClose
	V_DEF	_LibExpunge
	V_DEF	_LibReserved

	V_DEF	_ObtainClassEngine

	DC.W   -1

LibDataTable:
	INITBYTE	LN_TYPE,NT_LIBRARY
	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,(LIBF_SUMUSED!LIBF_CHANGED)
	INITWORD	LIB_VERSION,VERSION
	INITWORD	LIB_REVISION,REVISION
	INITLONG	LIB_IDSTRING,LibId
	DC.W		0

	CNOP    0,4

;-----------------------------------------------------------------------

	END
