#
# $PROJECT: Include Makefiles
#
# $VER: sasc.mk 1.2 (02.09.95)
#
# by
#
# Stefan Ruppert , Windthorststrasse 5 , 65439 Floersheim , GERMANY
#
# (C) Copyright 1995
# All Rights Reserved !
#
# $HISTORY:
#
# 02.09.95 : 001.002 : added checkinsym
# 21.07.95 : 001.001 : initial
#

##############################################################################
#
# command to use including path
#

SC      = sc:c/sc
CC      = sc:c/sc
LD      = sc:c/slink
MV      = c:move
RM      = rm
CP      = cp
MKPROTO = c:swtools/mkproto
MKPRAGMA= c:swtools/pragma_gen
CI      = ci
CO      = co
MKDIR   = mkdir

##############################################################################
#
# GNUMake SAS-C pattern rules
#
# These rules compiles every c and assembler source and puts the output to
# the OBJDIR directory
#

$(OBJDIR)/%.o: %.asm
	$(SC) $(SCOPTS) $(DEBUG) $(SCOPTIMIZE) ASM $< OBJNAME $(subst /objs/,objs:,$@)

$(OBJDIR)/%.o: %.cc
	$(SC) $(SCOPTS) $(DEBUG) $(SCOPTIMIZE) CXXSRC $< OBJNAME t:
	$(MV) t:$(@F) $(subst /objs/,objs:,$@)

$(OBJDIR)/%.o: %.c
	$(SC) $(SCOPTS) $(DEBUG) $(SCOPTIMIZE) $(GSTOPTS) CSRC $< OBJNAME t:
	$(MV) t:$(@F) $(subst /objs/,objs:,$@)

##############################################################################
#
# make SAS-C GST file
#

$(GST): $(GSTINC)
		  $(SC) MGST $(subst /objs/,objs:,$(GST)) $(GSTINC) $(INCDIRS) NOOBJNAME NOICON

##############################################################################
#
# make prototypes
#

protos:  $(PROTOS)

$(PROTOS): $(SRCS)
	$(MKPROTO) $(SRCS) TO $(PROTOS)

##############################################################################
#
# generate pragmas out of fd files
#

$(LIBPRAGMA): $(LIBFD) $(LIBPROTOS)
	$(MKPRAGMA) $(subst ..,,$(LIBFD)) $(subst ..,,$(LIBPRAGMA)) $(subst ..,,$(LIBPROTOS))

##############################################################################
#
# check in all files
#

checkin:
	$(CI) -I -r$(VERSION).$(REVISION) -t-initial $(subst RCS,,$(wildcard *))

checkinsym:
	$(CI) -I -NV$(VERSION)_$(REVISION) -r -t-initial $(subst RCS,,$(wildcard *))

checkout:
	$(CO) -l $(subst RCS/,,$(wildcard RCS/*))

##############################################################################
#
# make the object directory
#

$(OBJDIR):
	$(MKDIR) $(OBJDIR)

