#
# $PROJECT: Include Makefiles
#
# $VER: gcc.mk 0.1 (21.07.95)
#
# by
#
# Stefan Ruppert , Windthorststrasse 5 , 65439 Floersheim , GERMANY
#
# (C) Copyright 1995
# All Rights Reserved !
#
# $HISTORY:
#
# 21.07.95 : 000.001 : initial
#

##############################################################################
#
# GNUMake GCC-C pattern rules
#
# These rules compiles every c and c++ source and puts the output to
# the OBJDIR directory
#

$(OBJDIR)/%.o: %.cc
	gcc $(GCCOPTS) $(GCCDEBUG) $(GCCOPTIMIZE) $< -c -o $@

$(OBJDIR)/%.o: %.c
	gcc $(GCCOPTS) $(GCCDEBUG) $(GCCOPTIMIZE) $< -c -o $@

##############################################################################
#
# make prototypes
#

protos:  $(PROTOS)

$(PROTOS): $(SRCS)
	c:swtools/mkproto $(SRCS) TO $(PROTOS)

##############################################################################
#
# rcs entry points
#

checkin:
	$(CI) -I -r$(VERSION).$(REVISION) -t-initial $(subst RCS,,$(wildcard *))

checkinsym:
	$(CI) -I -NV$(VERSION)_$(REVISION) -r -t-initial $(subst RCS,,$(wildcard *))

checkout:
	$(CO) -l $(filter-out Makefile%,$(subst RCS/,,$(wildcard RCS/*)))

##############################################################################
#
# make the object directory
#

$(OBJDIR):
	mkdir $(OBJDIR)

##############################################################################
#
# make dependency include makefile
#

makedep:
	gcc -MM $(SRCS) $(GCCOPTS) >$(MAKEDEP)

